tclap: TCLAP::UnlabeledMultiArg< T > Class Template Reference

tclap 1.2.5

Public Member Functions | List of all members
TCLAP::UnlabeledMultiArg< T > Class Template Reference

Just like a MultiArg, except that the arguments are unlabeled. More...

`#include <UnlabeledMultiArg.h>`

Inheritance diagram for TCLAP::UnlabeledMultiArg< T >:
[legend]
Collaboration diagram for TCLAP::UnlabeledMultiArg< T >:
[legend]

## Public Member Functions
| UnlabeledMultiArg (const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, bool ignoreable=false, Visitor *v=NULL)
| Constructor. More...
| UnlabeledMultiArg (const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, CmdLineInterface &parser, bool ignoreable=false, Visitor *v=NULL)
| Constructor. More...
| UnlabeledMultiArg (const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, bool ignoreable=false, Visitor *v=NULL)
| Constructor. More...
| UnlabeledMultiArg (const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, CmdLineInterface &parser, bool ignoreable=false, Visitor *v=NULL)
| Constructor. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument. More...
virtual std::string | shortID (const std::string &val="val") const
| Returns the a short id string. More...
virtual std::string | longID (const std::string &val="val") const
| Returns the a long id string. More...
virtual bool | operator== (const Arg &a) const
| Operator ==. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Pushes this to back of list rather than front. More...
Public Member Functions inherited from TCLAP::MultiArg< T >
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor. More...
const std::vector< T > & | getValue () const
| Returns a vector of type T containing the values parsed from the command line. More...
const_iterator | begin () const
| Returns an iterator over the values parsed from the command line. More...
const_iterator | end () const
| Returns the end of the values parsed from the command line. More...
virtual bool | isRequired () const
| Once we've matched the first value, then the arg is no longer required. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...
Public Member Functions inherited from TCLAP::Arg
virtual | ~Arg ()
| Destructor. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...

## Additional Inherited Members
Public Types inherited from TCLAP::MultiArg< T >
typedef std::vector< T > | container_type
typedef container_type::iterator | iterator
typedef container_type::const_iterator | const_iterator
Static Public Member Functions inherited from TCLAP::Arg
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...
Protected Member Functions inherited from TCLAP::MultiArg< T >
void | _extractValue (const std::string &val)
| Extracts the value from the string. More...
Protected Member Functions inherited from TCLAP::Arg
void | _checkWithVisitor () const
| Performs the special handling described by the Visitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...
Protected Attributes inherited from TCLAP::MultiArg< T >
std::vector< T > | _values
| The list of values parsed from the CmdLine. More...
std::string | _typeDesc
| The description of type T to be used in the usage. More...
Constraint< T > * | _constraint
| A list of constraint on this Arg. More...
bool | _allowMore
| Used by XorHandler to decide whether to keep parsing for this arg. More...
Protected Attributes inherited from TCLAP::Arg
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single word namd identifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a visitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Detailed Description

### template<class T>
class TCLAP::UnlabeledMultiArg< T >

Just like a MultiArg, except that the arguments are unlabeled.

Basically, this Arg will slurp up everything that hasn't been matched to another Arg.

Definition at line 43 of file UnlabeledMultiArg.h.

## Constructor & Destructor Documentation

## ◆ UnlabeledMultiArg() [1/4]

template<class T >

TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  name | - The name of the Arg. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  ignoreable | - Whether or not this argument can be ignored using the "--" flag.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 190 of file UnlabeledMultiArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledMultiArg() [2/4]

template<class T >

TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  name | - The name of the Arg. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  parser | - A CmdLine parser object to add this Arg to
  ignoreable | - Whether or not this argument can be ignored using the "--" flag.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 203 of file UnlabeledMultiArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::CmdLineInterface::add(), TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledMultiArg() [3/4]

template<class T >

TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  name | - The name of the Arg. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  ignoreable | - Whether or not this argument can be ignored using the "--" flag.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 219 of file UnlabeledMultiArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledMultiArg() [4/4]

template<class T >

TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  name | - The name of the Arg. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  parser | - A CmdLine parser object to add this Arg to
  ignoreable | - Whether or not this argument can be ignored using the "--" flag.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 232 of file UnlabeledMultiArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::CmdLineInterface::add(), TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## Member Function Documentation

## ◆ addToList()

template<class T >

void TCLAP::UnlabeledMultiArg< T >::addToList | ( | std::list< Arg * > & | argList | ) | const
| virtual

Pushes this to back of list rather than front.

Parameters

  argList | - The list this should be added to.

Reimplemented from TCLAP::Arg.

Definition at line 297 of file UnlabeledMultiArg.h.

## ◆ longID()

template<class T >

std::string TCLAP::UnlabeledMultiArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Returns the a long id string.

Used in the usage.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::MultiArg< T >.

Definition at line 281 of file UnlabeledMultiArg.h.

## ◆ operator==()

template<class T >

bool TCLAP::UnlabeledMultiArg< T >::operator== | ( | const Arg & | a | ) | const
| virtual

Operator ==.

Parameters

  a | - The Arg to be compared to this.

Reimplemented from TCLAP::Arg.

Definition at line 288 of file UnlabeledMultiArg.h.

References TCLAP::Arg::getDescription(), and TCLAP::Arg::getName().

Here is the call graph for this function:

## ◆ processArg()

template<class T >

bool TCLAP::UnlabeledMultiArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |
| virtual

Handles the processing of the argument.

This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings. Passed from main().

Reimplemented from TCLAP::MultiArg< T >.

Definition at line 248 of file UnlabeledMultiArg.h.

## ◆ shortID()

template<class T >

std::string TCLAP::UnlabeledMultiArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Returns the a short id string.

Used in the usage.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::MultiArg< T >.

Definition at line 274 of file UnlabeledMultiArg.h.

The documentation for this class was generated from the following file:

- UnlabeledMultiArg.h